﻿//This is the WinForms project that implements the depth histogram
//other items of code developed in the article are included and not used.


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Microsoft.Kinect;

using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using System.Windows.Forms.DataVisualization.Charting;

namespace kinectDepth
{
    public partial class Form1 : Form
    {

        KinectSensor sensor;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            sensor = KinectSensor.KinectSensors[0];
            sensor.DepthStream.Enable(DepthImageFormat.Resolution320x240Fps30);
            sensor.DepthFrameReady += DepthFrameReady;
            sensor.Start();
        
        }
        void DepthFrameReady(object sender, DepthImageFrameReadyEventArgs e)
        {

            DepthImageFrame imageFrame = e.OpenDepthImageFrame();
            if (imageFrame != null)
            {

                short[] pixelData = new short[imageFrame.PixelDataLength];
                imageFrame.CopyPixelDataTo(pixelData);
                int temp = 0;
                int[] count = new int[0x1FFF / 4 + 1];
                for (int i = 0; i < imageFrame.PixelDataLength; i++)
                {
                    temp = ((ushort)pixelData[i]) >> 3;
                    count[temp >> 2]++;
                }
                chart1.Series[0].Points.Clear();
                for (int i = 1; i < (0x1FFF / 4); i++)
                {
                    chart1.Series[0].Points.Add(count[i]);
                }
                Application.DoEvents();
                pictureBox1.Image = DepthToBitmap(imageFrame);

            }
        }
    


        int getValue(DepthImageFrame imageFrame, int x, int y)
        {
            short[] pixelData = new short[imageFrame.PixelDataLength];
            imageFrame.CopyPixelDataTo(pixelData);
            return ((ushort) pixelData[x + y * imageFrame.Width])>>3 ;
         
        }
        
        Bitmap DepthToBitmap(DepthImageFrame imageFrame)
        {
        
            short[] pixelData = new short[imageFrame.PixelDataLength];
            imageFrame.CopyPixelDataTo(pixelData);

            for (int i = 0; i < imageFrame.PixelDataLength; i++)
            {
                pixelData[i] =(short)(((ushort) pixelData[i])>>3);
           
            }

            Bitmap bmap = new Bitmap(
             imageFrame.Width,
             imageFrame.Height,
             PixelFormat.Format16bppRgb555);

            BitmapData bmapdata = bmap.LockBits(
                new Rectangle(0, 0, imageFrame.Width,
                       imageFrame.Height),
                ImageLockMode.WriteOnly,
                bmap.PixelFormat);
            IntPtr ptr = bmapdata.Scan0;
            Marshal.Copy(pixelData,
                         0,
                         ptr,
                         imageFrame.Width *
                         imageFrame.Height);
            bmap.UnlockBits(bmapdata);
            return bmap;
        }
              
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            sensor.Stop();
        }
    }
}

